// Copyright © 2017 Project Golan, all rights reserved.
// See COPYING for more information.
#include "g_stage.h"
#include "g_object.h"
#include "g_player.h"
#include "g_enemy.h"

#include <Doominati.h>

#include <stdio.h>

// Extern Functions ----------------------------------------------------------|

//
// GInit
//
void GInit(char const *resdecl)
{
   extern void R_ResDec_Load(char const *fname);

   printf("\n=====================\n"
          u8"オミ：影響の目    1.0\n"
          u8"Copyright © 2017 Project Golan, all rights reserved.\n\n");

   DGE_Renderer_SetVirtualRes(960, 720);

   printf("Loading resource declarations...\n");
   R_ResDec_Load(resdecl);

   printf("Loading object function table...\n");
   G_ObjDef_Init();
   G_ObjDef_AddType("Player", subtype_player, G_Player_propC, (DGE_CallbackType)G_Player_Think);
   G_ObjDef_AddType("Test", subtype_test, 0, (DGE_CallbackType)G_TestObj_Think);

   printf("Loading object definitions...\n");
   G_ObjDef_Load("objdefs.dod");

   printf("Ready.\n");
}

//
// main
//
[[__extern("asm")]] DGE_Callback
void main(void)
{
   GInit("resdecl.rd");
   G_Stage_LoadBase();
   G_Stage_Run(1);
}

// EOF
